diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-aggregation-test.cc ns-3.41/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.40/src/wifi/test/wifi-aggregation-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/wifi-aggregation-test.cc	2024-02-09 14:44:08.609795000 -0800
@@ -363,190 +526,89 @@
 TwoLevelAggregationTest::DoRun()
 {
     /*
-     * Create device and attach HT configuration.
-     */
-    m_device = CreateObject<WifiNetDevice>();
-    m_device->SetStandard(WIFI_STANDARD_80211n);
-    Ptr<HtConfiguration> htConfiguration = CreateObject<HtConfiguration>();
-    m_device->SetHtConfiguration(htConfiguration);
-
-    /*
-     * Create and configure phy layer.
-     */
-    m_phy = CreateObject<YansWifiPhy>();
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    m_phy->SetDevice(m_device);
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211n);
-    m_device->SetPhy(m_phy);
-
-    /*
-     * Create and configure manager.
-     */
-    m_factory = ObjectFactory();
-    m_factory.SetTypeId("ns3::ConstantRateWifiManager");
-    m_factory.Set("DataMode", StringValue("HtMcs7"));
-    m_manager = m_factory.Create<WifiRemoteStationManager>();
-    m_manager->SetupPhy(m_phy);
-    m_device->SetRemoteStationManager(m_manager);
-
-    /*
-     * Create and configure mac layer.
-     */
-    m_mac = CreateObjectWithAttributes<StaWifiMac>("QosSupported", BooleanValue(true));
-    m_mac->SetDevice(m_device);
-    m_mac->SetWifiRemoteStationManager(m_manager);
-    m_mac->SetAddress(Mac48Address("00:00:00:00:00:01"));
-    m_mac->SetWifiPhys({m_phy});
-    m_mac->ConfigureStandard(WIFI_STANDARD_80211n);
-    Ptr<FrameExchangeManager> fem = m_mac->GetFrameExchangeManager();
-    Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
-    protectionManager->SetWifiMac(m_mac);
-    fem->SetProtectionManager(protectionManager);
-    Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager>();
-    ackManager->SetWifiMac(m_mac);
-    fem->SetAckManager(ackManager);
-    m_device->SetMac(m_mac);
-    m_mac->SetState(StaWifiMac::ASSOCIATED);
-    m_mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
-
-    /*
-     * Configure aggregation.
-     */
-    m_mac->SetAttribute("BE_MaxAmsduSize", UintegerValue(4095));
-    m_mac->SetAttribute("BE_MaxAmpduSize", UintegerValue(65535));
-    HtCapabilities htCapabilities;
-    htCapabilities.SetMaxAmsduLength(7935);
-    htCapabilities.SetMaxAmpduLength(65535);
-    m_manager->AddStationHtCapabilities(Mac48Address("00:00:00:00:00:02"), htCapabilities);
-
-    /*
      * Create dummy packets of 1500 bytes and fill mac header fields that will be used for the
      * tests.
      */
-    Ptr<const Packet> pkt = Create<Packet>(1500);
-    WifiMacHeader hdr;
-    hdr.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-    hdr.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
+    EnqueuePkts(3, 1500, Mac48Address("00:00:00:00:00:02"));
 
-    //-----------------------------------------------------------------------------------------------------
+    //---------------------------------------------------------------------------------------------
 
     /*
      * Test MSDU and MPDU aggregation. Three MSDUs are in the queue and the maximum A-MSDU size
      * is such that only two MSDUs can be aggregated. Therefore, the first MPDU we get contains
      * an A-MSDU of 2 MSDUs.
      */
-    Ptr<HtFrameExchangeManager> htFem = DynamicCast<HtFrameExchangeManager>(fem);
-    Ptr<MsduAggregator> msduAggregator = htFem->GetMsduAggregator();
-    Ptr<MpduAggregator> mpduAggregator = htFem->GetMpduAggregator();
-
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(Create<Packet>(1500), hdr));
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(Create<Packet>(1500), hdr));
-    m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(Create<Packet>(1500), hdr));
+    auto fem = m_mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID);
+    auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
+    auto msduAggregator = htFem->GetMsduAggregator();
+    auto mpduAggregator = htFem->GetMpduAggregator();
 
-    Ptr<WifiMpdu> peeked = m_mac->GetBEQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    auto peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     WifiTxParameters txParams;
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
     htFem->TryAddMpdu(peeked, txParams, Time::Min());
-    Ptr<WifiMpdu> item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
+    auto item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
 
     bool result{item};
     NS_TEST_EXPECT_MSG_EQ(result, true, "aggregation failed");
     NS_TEST_EXPECT_MSG_EQ(item->GetPacketSize(), 3030, "wrong packet size");
 
     // dequeue the MSDUs
-    htFem->DequeueMpdu(item);
+    DequeueMpdus({item});
 
-    NS_TEST_EXPECT_MSG_EQ(m_mac->GetBEQueue()->GetWifiMacQueue()->GetNPackets(),
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                           1,
                           "Unexpected number of MSDUs left in the EDCA queue");
 
-    //-----------------------------------------------------------------------------------------------------
+    //---------------------------------------------------------------------------------------------
 
     /*
      * A-MSDU aggregation fails when there is just one MSDU in the queue.
      */
 
-    peeked = m_mac->GetBEQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
     htFem->TryAddMpdu(peeked, txParams, Time::Min());
     item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
 
     NS_TEST_EXPECT_MSG_EQ(item, nullptr, "A-MSDU aggregation did not fail");
 
-    htFem->DequeueMpdu(peeked);
+    DequeueMpdus({peeked});
 
-    NS_TEST_EXPECT_MSG_EQ(m_mac->GetBEQueue()->GetWifiMacQueue()->GetNPackets(),
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                           0,
                           "queue should be empty");
 
-    //-----------------------------------------------------------------------------------------------------
+    //---------------------------------------------------------------------------------------------
 
     /*
      * Aggregation of MPDUs is stopped to prevent that the PPDU duration exceeds the TXOP limit.
-     * In this test, the VI AC is used, which has a default TXOP limit of 3008 microseconds.
+     * In this test, a TXOP limit of 3008 microseconds is used.
      */
 
-    // Establish agreement.
-    uint8_t tid = 5;
-    MgtAddBaRequestHeader reqHdr;
-    reqHdr.SetImmediateBlockAck();
-    reqHdr.SetTid(tid);
-    reqHdr.SetBufferSize(64);
-    reqHdr.SetTimeout(0);
-    reqHdr.SetStartingSequence(0);
-    m_mac->GetVIQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, hdr.GetAddr1());
-
-    MgtAddBaResponseHeader respHdr;
-    StatusCode code;
-    code.SetSuccess();
-    respHdr.SetStatusCode(code);
-    respHdr.SetAmsduSupport(reqHdr.IsAmsduSupported());
-    respHdr.SetImmediateBlockAck();
-    respHdr.SetTid(reqHdr.GetTid());
-    respHdr.SetBufferSize(64);
-    respHdr.SetTimeout(reqHdr.GetTimeout());
-    m_mac->GetVIQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, hdr.GetAddr1(), 0);
-
-    m_mac->SetAttribute("VI_MaxAmsduSize", UintegerValue(3050)); // max 2 MSDUs per A-MSDU
-    m_mac->SetAttribute("VI_MaxAmpduSize", UintegerValue(65535));
-    m_mac->GetVIQueue()->SetAttribute(
-        "TxopLimits",
-        AttributeContainerValue<TimeValue>(std::vector<Time>{MicroSeconds(3008)}));
-    m_manager->SetAttribute("DataMode", StringValue("HtMcs2")); // 19.5Mbps
-
-    hdr.SetQosTid(tid);
-
     // Add 10 MSDUs to the EDCA queue
-    for (uint8_t i = 0; i < 10; i++)
-    {
-        m_mac->GetVIQueue()->GetWifiMacQueue()->Enqueue(
-            Create<WifiMpdu>(Create<Packet>(1300), hdr));
-    }
+    EnqueuePkts(10, 1300, Mac48Address("00:00:00:00:00:02"));
 
-    peeked = m_mac->GetVIQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
-    Time txopLimit = m_mac->GetVIQueue()->GetTxopLimit(); // 3.008 ms
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
 
     // Compute the first MPDU to be aggregated in an A-MPDU. It must contain an A-MSDU
     // aggregating two MSDUs
-    item = m_mac->GetVIQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, txopLimit, true);
+    item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, m_params.txopLimit, true);
 
     NS_TEST_EXPECT_MSG_EQ(std::distance(item->begin(), item->end()),
                           2,
                           "There must be 2 MSDUs in the A-MSDU");
 
-    auto mpduList = mpduAggregator->GetNextAmpdu(item, txParams, txopLimit);
+    auto mpduList = mpduAggregator->GetNextAmpdu(item, txParams, m_params.txopLimit);
 
     // The maximum number of bytes that can be transmitted in a TXOP is (approximately, as we
     // do not consider that the preamble is transmitted at a different rate):
@@ -561,23 +623,96 @@
     NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "aggregation failed");
     NS_TEST_EXPECT_MSG_EQ(mpduList.size(), 3, "Unexpected number of MPDUs in the A-MPDU");
     NS_TEST_EXPECT_MSG_EQ(mpduList.at(0)->GetSize(), 2660, "Unexpected size of the first MPDU");
+    NS_TEST_EXPECT_MSG_EQ(mpduList.at(0)->GetHeader().IsQosAmsdu(),
+                          true,
+                          "Expecting the first MPDU to contain an A-MSDU");
     NS_TEST_EXPECT_MSG_EQ(mpduList.at(1)->GetSize(), 2660, "Unexpected size of the second MPDU");
-    NS_TEST_EXPECT_MSG_EQ(mpduList.at(2)->GetSize(), 1330, "Unexpected size of the first MPDU");
+    NS_TEST_EXPECT_MSG_EQ(mpduList.at(1)->GetHeader().IsQosAmsdu(),
+                          true,
+                          "Expecting the second MPDU to contain an A-MSDU");
+    NS_TEST_EXPECT_MSG_EQ(mpduList.at(2)->GetSize(), 1330, "Unexpected size of the third MPDU");
+    NS_TEST_EXPECT_MSG_EQ(mpduList.at(2)->GetHeader().IsQosAmsdu(),
+                          false,
+                          "Expecting the third MPDU not to contain an A-MSDU");
 
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(mpduList);
-    htFem->DequeuePsdu(psdu);
+    auto psdu = Create<WifiPsdu>(mpduList);
+    NS_TEST_EXPECT_MSG_EQ(psdu->GetSize(), 6662, "Unexpected size of the A-MPDU");
 
-    NS_TEST_EXPECT_MSG_EQ(m_mac->GetVIQueue()->GetWifiMacQueue()->GetNPackets(),
-                          5,
-                          "Unexpected number of MSDUs left in the EDCA queue");
+    // we now have two A-MSDUs and 6 MSDUs in the queue (5 MSDUs with no assigned sequence number)
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                          8,
+                          "Unexpected number of items left in the EDCA queue");
 
-    NS_TEST_EXPECT_MSG_EQ(psdu->GetSize(), 6662, "Unexpected size of the A-MPDU");
+    // prepare another A-MPDU (e.g., for transmission on another link)
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID, 0, psdu->GetAddr1(), mpduList.at(2));
+    txParams.Clear();
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
 
-    Simulator::Destroy();
+    // Compute the first MPDU to be aggregated in an A-MPDU. It must contain an A-MSDU
+    // aggregating two MSDUs
+    item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, m_params.txopLimit, true);
 
-    m_device->Dispose();
-    m_device = nullptr;
-    htConfiguration = nullptr;
+    NS_TEST_EXPECT_MSG_EQ(std::distance(item->begin(), item->end()),
+                          2,
+                          "There must be 2 MSDUs in the A-MSDU");
+
+    auto mpduList2 = mpduAggregator->GetNextAmpdu(item, txParams, m_params.txopLimit);
+
+    // we now have two A-MSDUs, one MSDU, two A-MSDUs and one MSDU in the queue (all with assigned
+    // sequence number)
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                          6,
+                          "Unexpected number of items left in the EDCA queue");
+
+    // unassign sequence numbers for all MPDUs (emulates an RTS/CTS failure on both links)
+    mpduList.at(0)->UnassignSeqNo();
+    mpduList.at(1)->UnassignSeqNo();
+    mpduList.at(2)->UnassignSeqNo();
+    mpduList2.at(0)->UnassignSeqNo();
+    mpduList2.at(1)->UnassignSeqNo();
+    mpduList2.at(2)->UnassignSeqNo();
+
+    // set A-MSDU max size to a large value
+    m_mac->SetAttribute("BE_MaxAmsduSize", UintegerValue(7000));
+
+    // A-MSDU aggregation now fails because the first item in the queue contain A-MSDUs
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    txParams.Clear();
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+
+    htFem->TryAddMpdu(peeked, txParams, Time::Min());
+    item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
+
+    NS_TEST_EXPECT_MSG_EQ(item, nullptr, "Expecting not to be able to aggregate A-MSDUs");
+
+    // remove the first two items in the queue (containing A-MSDUs)
+    DequeueMpdus({mpduList.at(0), mpduList.at(1)});
+
+    // we now have one MSDU, two A-MSDUs and one MSDU in the queue
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                          4,
+                          "Unexpected number of items left in the EDCA queue");
+
+    peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    txParams.Clear();
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+
+    NS_TEST_EXPECT_MSG_EQ(peeked->GetHeader().IsQosAmsdu(),
+                          false,
+                          "Expecting the peeked MPDU not to contain an A-MSDU");
+
+    item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
+
+    // A-MSDU aggregation is not attempted because the next item contains an A-MSDU
+    NS_TEST_EXPECT_MSG_EQ(item->GetHeader().IsQosAmsdu(),
+                          false,
+                          "Expecting the returned MPDU not to contain an A-MSDU");
 }
 
 /**
@@ -587,187 +722,193 @@
  * \brief 802.11ax aggregation test which permits 64 or 256 MPDUs in A-MPDU according to the
  * negotiated buffer size.
  */
-class HeAggregationTest : public TestCase
+class HeAggregationTest : public AmpduAggregationTest
 {
   public:
-    HeAggregationTest();
-
-  private:
-    void DoRun() override;
     /**
-     * Run test for a given buffer size
+     * Constructor.
      *
-     * \param bufferSize the buffer size
+     * \param bufferSize the size (in number of MPDUs) of the BlockAck buffer
      */
-    void DoRunSubTest(uint16_t bufferSize);
-    Ptr<WifiNetDevice> m_device;             ///< WifiNetDevice
-    Ptr<StaWifiMac> m_mac;                   ///< Mac
-    Ptr<YansWifiPhy> m_phy;                  ///< Phy
-    Ptr<WifiRemoteStationManager> m_manager; ///< remote station manager
-    ObjectFactory m_factory;                 ///< factory
+    HeAggregationTest(uint16_t bufferSize);
+
+  private:
+    void DoRun() override;
 };
 
-HeAggregationTest::HeAggregationTest()
-    : TestCase("Check the correctness of 802.11ax aggregation operations")
+HeAggregationTest::HeAggregationTest(uint16_t bufferSize)
+    : AmpduAggregationTest("Check the correctness of 802.11ax aggregation operations, size=" +
+                               std::to_string(bufferSize),
+                           Params{.standard = WIFI_STANDARD_80211ax,
+                                  .nLinks = 1,
+                                  .dataMode = "HeMcs11",
+                                  .bufferSize = bufferSize,
+                                  .maxAmsduSize = 0,
+                                  .maxAmpduSize = 65535,
+                                  .txopLimit = Seconds(0)})
 {
 }
 
 void
-HeAggregationTest::DoRunSubTest(uint16_t bufferSize)
+HeAggregationTest::DoRun()
 {
     /*
-     * Create device and attach configurations.
-     */
-    m_device = CreateObject<WifiNetDevice>();
-    Ptr<HtConfiguration> htConfiguration = CreateObject<HtConfiguration>();
-    m_device->SetHtConfiguration(htConfiguration);
-    Ptr<VhtConfiguration> vhtConfiguration = CreateObject<VhtConfiguration>();
-    m_device->SetVhtConfiguration(vhtConfiguration);
-    Ptr<HeConfiguration> heConfiguration = CreateObject<HeConfiguration>();
-    m_device->SetHeConfiguration(heConfiguration);
-
-    /*
-     * Create and configure phy layer.
+     * Test behavior when 300 packets are ready for transmission
      */
-    m_phy = CreateObject<YansWifiPhy>();
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
-    m_phy->SetInterferenceHelper(interferenceHelper);
-    m_phy->SetDevice(m_device);
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    m_device->SetPhy(m_phy);
+    EnqueuePkts(300, 100, Mac48Address("00:00:00:00:00:02"));
 
-    /*
-     * Create and configure manager.
-     */
-    m_factory = ObjectFactory();
-    m_factory.SetTypeId("ns3::ConstantRateWifiManager");
-    m_factory.Set("DataMode", StringValue("HeMcs11"));
-    m_manager = m_factory.Create<WifiRemoteStationManager>();
-    m_manager->SetupPhy(m_phy);
-    m_device->SetRemoteStationManager(m_manager);
-
-    /*
-     * Create and configure mac layer.
-     */
-    m_mac = CreateObjectWithAttributes<StaWifiMac>("QosSupported", BooleanValue(true));
-    m_mac->SetDevice(m_device);
-    m_mac->SetWifiRemoteStationManager(m_manager);
-    m_mac->SetAddress(Mac48Address("00:00:00:00:00:01"));
-    m_mac->SetWifiPhys({m_phy});
-    m_mac->ConfigureStandard(WIFI_STANDARD_80211ax);
-    Ptr<FrameExchangeManager> fem = m_mac->GetFrameExchangeManager();
-    Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
-    protectionManager->SetWifiMac(m_mac);
-    fem->SetProtectionManager(protectionManager);
-    Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager>();
-    ackManager->SetWifiMac(m_mac);
-    fem->SetAckManager(ackManager);
-    m_device->SetMac(m_mac);
-    m_mac->SetState(StaWifiMac::ASSOCIATED);
-    m_mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
+    auto fem = m_mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID);
+    auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
+    auto mpduAggregator = htFem->GetMpduAggregator();
 
-    /*
-     * Configure aggregation.
-     */
-    HeCapabilities heCapabilities;
-    m_manager->AddStationHeCapabilities(Mac48Address("00:00:00:00:00:02"), heCapabilities);
-
-    /*
-     * Fill mac header fields.
-     */
-    WifiMacHeader hdr;
-    hdr.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-    hdr.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
-    uint16_t sequence = m_mac->m_txMiddle->PeekNextSequenceNumberFor(&hdr);
-    hdr.SetSequenceNumber(sequence);
-    hdr.SetFragmentNumber(0);
-    hdr.SetNoMoreFragments();
-    hdr.SetNoRetry();
-
-    /*
-     * Establish agreement.
-     */
-    MgtAddBaRequestHeader reqHdr;
-    reqHdr.SetImmediateBlockAck();
-    reqHdr.SetTid(0);
-    reqHdr.SetBufferSize(bufferSize);
-    reqHdr.SetTimeout(0);
-    reqHdr.SetStartingSequence(0);
-    m_mac->GetBEQueue()->GetBaManager()->CreateOriginatorAgreement(reqHdr, hdr.GetAddr1());
-
-    MgtAddBaResponseHeader respHdr;
-    StatusCode code;
-    code.SetSuccess();
-    respHdr.SetStatusCode(code);
-    respHdr.SetAmsduSupport(reqHdr.IsAmsduSupported());
-    respHdr.SetImmediateBlockAck();
-    respHdr.SetTid(reqHdr.GetTid());
-    respHdr.SetBufferSize(bufferSize);
-    respHdr.SetTimeout(reqHdr.GetTimeout());
-    m_mac->GetBEQueue()->GetBaManager()->UpdateOriginatorAgreement(respHdr, hdr.GetAddr1(), 0);
-
-    /*
-     * Test behavior when 300 packets are ready for transmission but negotiated buffer size is 64
-     */
-    Ptr<HtFrameExchangeManager> htFem = DynamicCast<HtFrameExchangeManager>(fem);
-    Ptr<MpduAggregator> mpduAggregator = htFem->GetMpduAggregator();
-
-    for (uint16_t i = 0; i < 300; i++)
-    {
-        Ptr<const Packet> pkt = Create<Packet>(100);
-        WifiMacHeader hdr;
-
-        hdr.SetAddr1(Mac48Address("00:00:00:00:00:02"));
-        hdr.SetAddr2(Mac48Address("00:00:00:00:00:01"));
-        hdr.SetType(WIFI_MAC_QOSDATA);
-        hdr.SetQosTid(0);
-
-        m_mac->GetBEQueue()->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(pkt, hdr));
-    }
-
-    Ptr<WifiMpdu> peeked = m_mac->GetBEQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
+    auto peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     WifiTxParameters txParams;
-    txParams.m_txVector =
-        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
-                                                              m_phy->GetChannelWidth());
-    Ptr<WifiMpdu> item =
-        m_mac->GetBEQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
+    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+        peeked->GetHeader(),
+        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    auto item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     auto mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(mpduList);
-    htFem->DequeuePsdu(psdu);
+    DequeueMpdus(mpduList);
 
     NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "MPDU aggregation failed");
     NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
-                          bufferSize,
-                          "A-MPDU should contain " << bufferSize << " MPDUs");
-    uint16_t expectedRemainingPacketsInQueue = 300 - bufferSize;
-    NS_TEST_EXPECT_MSG_EQ(m_mac->GetBEQueue()->GetWifiMacQueue()->GetNPackets(),
+                          m_params.bufferSize,
+                          "A-MPDU contains an unexpected number of MPDUs");
+    uint16_t expectedRemainingPacketsInQueue = 300 - m_params.bufferSize;
+    NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                           expectedRemainingPacketsInQueue,
-                          "queue should contain 300 - " << bufferSize << " = "
-                                                        << expectedRemainingPacketsInQueue
-                                                        << " packets");
-
-    Simulator::Destroy();
+                          "Queue contains an unexpected number of MPDUs");
+}
 
-    m_manager->Dispose();
-    m_manager = nullptr;
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief 802.11be aggregation test which permits up to 1024 MPDUs in A-MPDU according to the
+ * negotiated buffer size.
+ */
+class EhtAggregationTest : public AmpduAggregationTest
+{
+  public:
+    /**
+     * Constructor.
+     *
+     * \param bufferSize the size (in number of MPDUs) of the BlockAck buffer
+     */
+    EhtAggregationTest(uint16_t bufferSize);
 
-    m_device->Dispose();
-    m_device = nullptr;
+  private:
+    void DoRun() override;
+};
 
-    htConfiguration = nullptr;
-    vhtConfiguration = nullptr;
-    heConfiguration = nullptr;
+EhtAggregationTest::EhtAggregationTest(uint16_t bufferSize)
+    : AmpduAggregationTest("Check the correctness of 802.11be aggregation operations, size=" +
+                               std::to_string(bufferSize),
+                           Params{.standard = WIFI_STANDARD_80211be,
+                                  .nLinks = 2,
+                                  .dataMode = "EhtMcs13",
+                                  .bufferSize = bufferSize,
+                                  .maxAmsduSize = 0,
+                                  .maxAmpduSize = 102000,
+                                  .txopLimit = Seconds(0)})
+{
 }
 
 void
-HeAggregationTest::DoRun()
+EhtAggregationTest::DoRun()
 {
-    DoRunSubTest(64);
-    DoRunSubTest(256);
+    /*
+     * Test behavior when 1200 packets of 100 bytes each are ready for transmission. The max
+     * A-MPDU size limit (102000 B) is computed to have at most 750 MPDUs aggregated in a single
+     * A-MPDU (each MPDU is 130 B, plus 4 B of A-MPDU subframe header, plus 2 B of padding).
+     */
+    EnqueuePkts(1200, 100, Mac48Address("00:00:00:00:00:02"));
+    const std::size_t maxNMpdus = 750;
+
+    for (uint8_t linkId = 0; linkId < m_params.nLinks; linkId++)
+    {
+        auto fem = m_mac->GetFrameExchangeManager(linkId);
+        auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
+        auto mpduAggregator = htFem->GetMpduAggregator();
+        std::vector<Ptr<WifiMpdu>> mpduList;
+
+        auto peeked = GetBeQueue()->PeekNextMpdu(linkId);
+        if (peeked)
+        {
+            WifiTxParameters txParams;
+            txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
+                peeked->GetHeader(),
+                m_phys.at(linkId)->GetChannelWidth());
+            auto item = GetBeQueue()->GetNextMpdu(linkId, peeked, txParams, Time::Min(), true);
+
+            mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
+            DequeueMpdus(mpduList);
+        }
+
+        uint16_t expectedRemainingPacketsInQueue;
+
+        if (m_params.bufferSize >= maxNMpdus)
+        {
+            // two A-MPDUs are transmitted concurrently on the two links and together saturate
+            // the transmit window
+            switch (linkId)
+            {
+            case 0:
+                // the first A-MPDU includes maxNMpdus MPDUs
+                NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "MPDU aggregation failed");
+                NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
+                                      maxNMpdus,
+                                      "A-MPDU contains an unexpected number of MPDUs");
+                expectedRemainingPacketsInQueue = 1200 - maxNMpdus;
+                NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                                      expectedRemainingPacketsInQueue,
+                                      "Queue contains an unexpected number of MPDUs");
+                break;
+            case 1:
+                // the second A-MPDU includes bufferSize - maxNMpdus MPDUs
+                NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "MPDU aggregation failed");
+                NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
+                                      m_params.bufferSize - maxNMpdus,
+                                      "A-MPDU contains an unexpected number of MPDUs");
+                expectedRemainingPacketsInQueue = 1200 - m_params.bufferSize;
+                NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                                      expectedRemainingPacketsInQueue,
+                                      "Queue contains an unexpected number of MPDUs");
+                break;
+            default:
+                NS_TEST_ASSERT_MSG_EQ(true, false, "Unexpected link ID " << +linkId);
+            }
+        }
+        else
+        {
+            // one A-MPDU is transmitted that saturates the transmit window
+            switch (linkId)
+            {
+            case 0:
+                // the first A-MPDU includes bufferSize MPDUs
+                NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), false, "MPDU aggregation failed");
+                NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
+                                      m_params.bufferSize,
+                                      "A-MPDU contains an unexpected number of MPDUs");
+                expectedRemainingPacketsInQueue = 1200 - m_params.bufferSize;
+                NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                                      expectedRemainingPacketsInQueue,
+                                      "Queue contains an unexpected number of MPDUs");
+                break;
+            case 1:
+                // no more MPDUs can be sent, aggregation fails
+                NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), true, "MPDU aggregation did not fail");
+                expectedRemainingPacketsInQueue = 1200 - m_params.bufferSize;
+                NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
+                                      expectedRemainingPacketsInQueue,
+                                      "Queue contains an unexpected number of MPDUs");
+                break;
+            default:
+                NS_TEST_ASSERT_MSG_EQ(true, false, "Unexpected link ID " << +linkId);
+            }
+        }
+    }
 }
 
 /**
@@ -999,7 +1140,10 @@
 {
     AddTestCase(new AmpduAggregationTest, TestCase::QUICK);
     AddTestCase(new TwoLevelAggregationTest, TestCase::QUICK);
-    AddTestCase(new HeAggregationTest, TestCase::QUICK);
+    AddTestCase(new HeAggregationTest(64), TestCase::QUICK);
+    AddTestCase(new HeAggregationTest(256), TestCase::QUICK);
+    AddTestCase(new EhtAggregationTest(512), TestCase::QUICK);
+    AddTestCase(new EhtAggregationTest(1024), TestCase::QUICK);
     AddTestCase(new PreservePacketsInAmpdus, TestCase::QUICK);
 }
 
